require 'optparse'
require 'drawy/version'
require 'drawy/application'

module Drawy
  autoload :Engine,          'drawy/engine'
  autoload :IO,              'drawy/io'
  autoload :Validator,       'drawy/validator'
  autoload :Error,           'drawy/error'
  autoload :InputError,      'drawy/error'
  autoload :ValidationError, 'drawy/error'

  class << self
    def run
      Drawy::Application.start
    rescue Drawy::Error => e
      $stderr.puts "#------------ #{e.message} ------------#"
      run
    rescue StandardError => e
      abort "#{e.backtrace.join("\n")}\n\n#{e.class} - #{e.message}\n\nSomething went wrong."
    end
  end
end
